﻿function menuManager(){
	this.popupSelector = 'div.menuVipad_0';
	this.headerSelector = 'ul.headMenuUL li';
	this.selectedPopupId = undefined;
	this.timeoutId = undefined;

	this.getSelectedHeaderId = function(){
		 if (this.selectedPopupId){
			 var popupElement = $('#' + this.selectedPopupId);
			 if (popupElement){
				 return popupElement.attr('name');
			 }
		 }
		return undefined;
	}
	/**
	 *
	 */
	this.undoHide = function(){
		if (this.timeoutId) {
			clearTimeout(this.timeoutId);
			this.timeoutId = undefined;
		}
	}
	/**
	 *
	 */
	this.fastHide = function(){
		this.undoHide();
		if (this.selectedPopupId){
			$('#' + this.selectedPopupId).fadeOut(100);//.css('display', 'none');
			this.selectedPopupId = undefined;
		}
	}
	/**
	 *
	 */
	this.hide = function(){
		/*if (this.timeoutId == undefined) {
			this.timeoutId = setTimeout( function(){ menu.fastHide(); }, 300);
		} */
		menu.fastHide();
	}
	/**
	 *
	 * @param popupId
	 */
	this.calculateAbsolutePosition = function(jQueryElement){
		var result = { top: 0, left: 0 };
		var counter = 0;
		while (jQueryElement && !jQueryElement.is('body') && counter < 1000){
			result.top += jQueryElement.get(0).offsetTop;
			result.left += jQueryElement.get(0).offsetLeft;
			if (jQueryElement == jQueryElement.offsetParent()) { break; }
			jQueryElement = jQueryElement.offsetParent();
			counter++;
		}
		return result;
	}
	/**
	 *
	 */
	this.show = function(popupId){
		if (this.selectedPopupId != popupId) { this.fastHide(); }
		this.selectedPopupId = popupId;
		if (this.selectedPopupId){
			this.undoHide();
			var popupElement = $('#' + this.selectedPopupId);
			if (popupElement && popupElement.css('display') == 'none'){
				$(this.popupSelector).fadeOut(100);
				var parentElement = $('#' + this.getSelectedHeaderId());
				if (parentElement){
					var position = parentElement.position();
					var height = parentElement.height();
					popupElement.css('position', 'absolute');
					popupElement.css('top', position.top + height + 4);
					popupElement.css('left', position.left);
				}
				this.fastHide();
				popupElement.fadeIn(200);
			}
		}
	}
	/**
	 *
	 * @param element
	 */
	this.checkHeaderElement = function(element){
		var breaker = 0;
		var breakCount = 500;
		element = $(element);
		while (element && breaker++ < breakCount){
			if (element.is(this.headerSelector)) {
				this.show(element.attr('name'));
				return true;
			}
			element = element.parent();
		}
		return false;
	}
	/**
	 *
	 * @param element
	 */
	this.checkPopupElement = function(element){
		var breaker = 0;
		var breakCount = 500;
		element = $(element);
		while (element && breaker++ < breakCount){
			if (element.is(this.popupSelector)) {
				this.show(element.attr('id'));
				return true;
			}
			element = element.parent();
		}
		return false
	}
	/**
	 *
	 */
	this.mousemove = function(event){
		var target = event.srcElement ? event.srcElement : event.target;
		var selectedHeaderId = this.getSelectedHeaderId();
		if (this.selectedPopupId && selectedHeaderId){
			var headerPosition = this.calculateAbsolutePosition($('#' + selectedHeaderId));
			var popupPosition = this.calculateAbsolutePosition($('#' + this.selectedPopupId));

			if (!(event.pageX > headerPosition.left && event.pageX < headerPosition.left + $('#' + selectedHeaderId).width()
					&& event.pageY >= headerPosition.top && event.pageY <= popupPosition.top)) {
				if (!menu.checkPopupElement(target)) {
					if (!menu.checkHeaderElement(target)){
						$(this.popupSelector).fadeOut(100);
						menu.hide();
					}
				}
			}
		}
		else {
			if (!menu.checkPopupElement(target)) {
				if (!menu.checkHeaderElement(target)){
					$(this.popupSelector).fadeOut(100);
					menu.hide();
				}
			}
		}
	}
}
var menu = new menuManager();

$(menu.headerSelector + ' a').click(function(){
	menu.fastHide();
});
$(menu.popupSelector + ' a').click(function(){
	menu.fastHide();
});
$(document).mousemove(function(event){ menu.mousemove(event); });

// Скрытие/показ левого меню
$(document).ready(function(){
	$menuButt = $(".left .dd img");
	$menuLeftTd = $("td.left");
	$menuLeftDiv = $("div.left");
	
	$menuButt.click(function(){
		if($(".left .menuUL").is(":visible")){	
			$menuLeftTd.animate({
		        width: "24px",
		        opacity: 1
		    }, 500 );
			$menuLeftDiv.animate({
		        width: "24px",
		        opacity: 0.0
		    }, 500 );
			setTimeout( function(){$menuLeftDiv.css("display", "none"); $menuButt.attr("src","img/menu_butt_open.png");}, 500);
		}else{
			$menuLeftDiv.css("display", "block");
			$menuLeftTd.animate({
		        width: "250px",
		        opacity: 1
		    }, 500 );
			$menuLeftDiv.animate({
		        width: "250px",
		        opacity: 1
		    }, 500 );
			setTimeout( function(){$menuButt.attr("src","img/menu_butt_close.png");}, 500);
		}	
	});
});